#include <luna.h>
#include <sys/syscall.h>
#include <time.h>
#include <unistd.h>

extern "C"
{
    clock_t clock()
    {
        return syscall(SYS_clock);
    }

    time_t time(
        time_t* tloc) // Very big FIXME: This is not the time of day, this just returns the same as clock() but in
                      // seconds. This is definitely wrong, but I'm not implementing a whole time system right now.
    {
        time_t result = (time_t)(syscall(SYS_clock) / CLOCKS_PER_SEC);
        if (tloc) { *tloc = result; }
        return result;
    }

    struct tm* localtime(const time_t*)
    {
        NOT_IMPLEMENTED("localtime");
    }

    struct tm* gmtime(const time_t*)
    {
        NOT_IMPLEMENTED("gmtime");
    }
}